(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('react-dom')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react', 'react-dom'], factory) :
    (factory((global.index = {}),global.React,global.ReactDOM));
}(this, (function (exports,React,reactDom) { 'use strict';

    var React__default = 'default' in React ? React['default'] : React;
    reactDom = reactDom && reactDom.hasOwnProperty('default') ? reactDom['default'] : reactDom;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    var getSliderStyles = function () { return ({
        rtgList: {
            display: "flex",
            margin: "auto",
            overflow: "hidden",
            position: "relative"
        },
        rtgWrapper: {
            left: 0,
            position: "absolute",
            right: 0
        }
    }); };

    // shim for using process in browser
    if (typeof global.setTimeout === 'function') ;
    if (typeof global.clearTimeout === 'function') ;

    // from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js
    var performance = global.performance || {};
    var performanceNow =
      performance.now        ||
      performance.mozNow     ||
      performance.msNow      ||
      performance.oNow       ||
      performance.webkitNow  ||
      function(){ return (new Date()).getTime() };

    // Copyright Joyent, Inc. and other Node contributors.

    function isNull(arg) {
      return arg === null;
    }

    /**
     * Function to get the wrapper style for transitioning child
     * @param transform Value of transform property of css
     * @param transition Value of transition property of css
     * @param opacity Value of opacity property of css
     * @param transitionTimingFunction Value of transition-timing-function property of css
     * @returns Css styles in json format
     */
    function getWrapperStyles(transform, transition, opacity, transitionTimingFunction) {
        return { transform: transform, transition: transition, opacity: opacity, transitionTimingFunction: transitionTimingFunction };
    }
    /**
     * This function checks if a variable is not undef or not null
     * @param subjectArg
     */
    function noNullOrUndefined(subjectArg) {
        return typeof subjectArg !== "undefined" && !isNull(subjectArg);
    }

    function TransitioningComponentChild(props) {
        var wrapperStyles;
        switch (props.state) {
            case "entering":
                wrapperStyles = getWrapperStyles(props.enteringTransform, "0", props.fadeOnSlide ? 0 : 1);
                break;
            case "entered":
                wrapperStyles = props.enter
                    ? getWrapperStyles(props.wrapperTransformCenter, props.sliderTransitionEnterTime, 1, props.sliderEnterTimingFunction)
                    : getWrapperStyles(props.wrapperTransformCenter, "0", 1);
                break;
            case "exiting":
                wrapperStyles = getWrapperStyles(props.wrapperTransformCenter, "0", 1);
                break;
            case "exited":
                wrapperStyles = props.enter
                    ? getWrapperStyles(props.enteringTransform, "0", props.fadeOnSlide ? 0 : 1)
                    : getWrapperStyles(props.exitingTransform, props.sliderTransitionExitTime, props.fadeOnSlide ? 0 : 1, props.sliderExitTimingFunction);
                break;
            default:
                throw new Error("Transition has no state");
        }
        return (React.createElement("div", { style: __assign({}, wrapperStyles, props.cssWrapperStyle) }, props.child));
    }

    function unwrapExports (x) {
    	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
    }

    function createCommonjsModule(fn, module) {
    	return module = { exports: {} }, fn(module, module.exports), module.exports;
    }

    /*
    object-assign
    (c) Sindre Sorhus
    @license MIT
    */
    /* eslint-disable no-unused-vars */
    var getOwnPropertySymbols = Object.getOwnPropertySymbols;
    var hasOwnProperty$1 = Object.prototype.hasOwnProperty;
    var propIsEnumerable = Object.prototype.propertyIsEnumerable;

    function toObject(val) {
    	if (val === null || val === undefined) {
    		throw new TypeError('Object.assign cannot be called with null or undefined');
    	}

    	return Object(val);
    }

    function shouldUseNative() {
    	try {
    		if (!Object.assign) {
    			return false;
    		}

    		// Detect buggy property enumeration order in older V8 versions.

    		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
    		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
    		test1[5] = 'de';
    		if (Object.getOwnPropertyNames(test1)[0] === '5') {
    			return false;
    		}

    		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
    		var test2 = {};
    		for (var i = 0; i < 10; i++) {
    			test2['_' + String.fromCharCode(i)] = i;
    		}
    		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
    			return test2[n];
    		});
    		if (order2.join('') !== '0123456789') {
    			return false;
    		}

    		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
    		var test3 = {};
    		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
    			test3[letter] = letter;
    		});
    		if (Object.keys(Object.assign({}, test3)).join('') !==
    				'abcdefghijklmnopqrst') {
    			return false;
    		}

    		return true;
    	} catch (err) {
    		// We don't expect any of the above to throw, but better to be safe.
    		return false;
    	}
    }

    var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
    	var from;
    	var to = toObject(target);
    	var symbols;

    	for (var s = 1; s < arguments.length; s++) {
    		from = Object(arguments[s]);

    		for (var key in from) {
    			if (hasOwnProperty$1.call(from, key)) {
    				to[key] = from[key];
    			}
    		}

    		if (getOwnPropertySymbols) {
    			symbols = getOwnPropertySymbols(from);
    			for (var i = 0; i < symbols.length; i++) {
    				if (propIsEnumerable.call(from, symbols[i])) {
    					to[symbols[i]] = from[symbols[i]];
    				}
    			}
    		}
    	}

    	return to;
    };

    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

    var ReactPropTypesSecret_1 = ReactPropTypesSecret;

    var printWarning = function() {};

    if (process.env.NODE_ENV !== 'production') {
      var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
      var loggedTypeFailures = {};

      printWarning = function(text) {
        var message = 'Warning: ' + text;
        if (typeof console !== 'undefined') {
          console.error(message);
        }
        try {
          // --- Welcome to debugging React ---
          // This error was thrown as a convenience so that you can use this stack
          // to find the callsite that caused this warning to fire.
          throw new Error(message);
        } catch (x) {}
      };
    }

    /**
     * Assert that the values match with the type specs.
     * Error messages are memorized and will only be shown once.
     *
     * @param {object} typeSpecs Map of name to a ReactPropType
     * @param {object} values Runtime values that need to be type-checked
     * @param {string} location e.g. "prop", "context", "child context"
     * @param {string} componentName Name of the component for error messages.
     * @param {?Function} getStack Returns the component stack.
     * @private
     */
    function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
      if (process.env.NODE_ENV !== 'production') {
        for (var typeSpecName in typeSpecs) {
          if (typeSpecs.hasOwnProperty(typeSpecName)) {
            var error;
            // Prop type validation may throw. In case they do, we don't want to
            // fail the render phase where it didn't fail before. So we log it.
            // After these have been cleaned up, we'll let them throw.
            try {
              // This is intentionally an invariant that gets caught. It's the same
              // behavior as without this statement except with a better message.
              if (typeof typeSpecs[typeSpecName] !== 'function') {
                var err = Error(
                  (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
                  'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
                );
                err.name = 'Invariant Violation';
                throw err;
              }
              error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
            } catch (ex) {
              error = ex;
            }
            if (error && !(error instanceof Error)) {
              printWarning(
                (componentName || 'React class') + ': type specification of ' +
                location + ' `' + typeSpecName + '` is invalid; the type checker ' +
                'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
                'You may have forgotten to pass an argument to the type checker ' +
                'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
                'shape all require an argument).'
              );

            }
            if (error instanceof Error && !(error.message in loggedTypeFailures)) {
              // Only monitor this failure once because there tends to be a lot of the
              // same error.
              loggedTypeFailures[error.message] = true;

              var stack = getStack ? getStack() : '';

              printWarning(
                'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
              );
            }
          }
        }
      }
    }

    var checkPropTypes_1 = checkPropTypes;

    var printWarning$1 = function() {};

    if (process.env.NODE_ENV !== 'production') {
      printWarning$1 = function(text) {
        var message = 'Warning: ' + text;
        if (typeof console !== 'undefined') {
          console.error(message);
        }
        try {
          // --- Welcome to debugging React ---
          // This error was thrown as a convenience so that you can use this stack
          // to find the callsite that caused this warning to fire.
          throw new Error(message);
        } catch (x) {}
      };
    }

    function emptyFunctionThatReturnsNull() {
      return null;
    }

    var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
      /* global Symbol */
      var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
      var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

      /**
       * Returns the iterator method function contained on the iterable object.
       *
       * Be sure to invoke the function with the iterable as context:
       *
       *     var iteratorFn = getIteratorFn(myIterable);
       *     if (iteratorFn) {
       *       var iterator = iteratorFn.call(myIterable);
       *       ...
       *     }
       *
       * @param {?object} maybeIterable
       * @return {?function}
       */
      function getIteratorFn(maybeIterable) {
        var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
        if (typeof iteratorFn === 'function') {
          return iteratorFn;
        }
      }

      /**
       * Collection of methods that allow declaration and validation of props that are
       * supplied to React components. Example usage:
       *
       *   var Props = require('ReactPropTypes');
       *   var MyArticle = React.createClass({
       *     propTypes: {
       *       // An optional string prop named "description".
       *       description: Props.string,
       *
       *       // A required enum prop named "category".
       *       category: Props.oneOf(['News','Photos']).isRequired,
       *
       *       // A prop named "dialog" that requires an instance of Dialog.
       *       dialog: Props.instanceOf(Dialog).isRequired
       *     },
       *     render: function() { ... }
       *   });
       *
       * A more formal specification of how these methods are used:
       *
       *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
       *   decl := ReactPropTypes.{type}(.isRequired)?
       *
       * Each and every declaration produces a function with the same signature. This
       * allows the creation of custom validation functions. For example:
       *
       *  var MyLink = React.createClass({
       *    propTypes: {
       *      // An optional string or URI prop named "href".
       *      href: function(props, propName, componentName) {
       *        var propValue = props[propName];
       *        if (propValue != null && typeof propValue !== 'string' &&
       *            !(propValue instanceof URI)) {
       *          return new Error(
       *            'Expected a string or an URI for ' + propName + ' in ' +
       *            componentName
       *          );
       *        }
       *      }
       *    },
       *    render: function() {...}
       *  });
       *
       * @internal
       */

      var ANONYMOUS = '<<anonymous>>';

      // Important!
      // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
      var ReactPropTypes = {
        array: createPrimitiveTypeChecker('array'),
        bool: createPrimitiveTypeChecker('boolean'),
        func: createPrimitiveTypeChecker('function'),
        number: createPrimitiveTypeChecker('number'),
        object: createPrimitiveTypeChecker('object'),
        string: createPrimitiveTypeChecker('string'),
        symbol: createPrimitiveTypeChecker('symbol'),

        any: createAnyTypeChecker(),
        arrayOf: createArrayOfTypeChecker,
        element: createElementTypeChecker(),
        instanceOf: createInstanceTypeChecker,
        node: createNodeChecker(),
        objectOf: createObjectOfTypeChecker,
        oneOf: createEnumTypeChecker,
        oneOfType: createUnionTypeChecker,
        shape: createShapeTypeChecker,
        exact: createStrictShapeTypeChecker,
      };

      /**
       * inlined Object.is polyfill to avoid requiring consumers ship their own
       * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
       */
      /*eslint-disable no-self-compare*/
      function is(x, y) {
        // SameValue algorithm
        if (x === y) {
          // Steps 1-5, 7-10
          // Steps 6.b-6.e: +0 != -0
          return x !== 0 || 1 / x === 1 / y;
        } else {
          // Step 6.a: NaN == NaN
          return x !== x && y !== y;
        }
      }
      /*eslint-enable no-self-compare*/

      /**
       * We use an Error-like object for backward compatibility as people may call
       * PropTypes directly and inspect their output. However, we don't use real
       * Errors anymore. We don't inspect their stack anyway, and creating them
       * is prohibitively expensive if they are created too often, such as what
       * happens in oneOfType() for any type before the one that matched.
       */
      function PropTypeError(message) {
        this.message = message;
        this.stack = '';
      }
      // Make `instanceof Error` still work for returned errors.
      PropTypeError.prototype = Error.prototype;

      function createChainableTypeChecker(validate) {
        if (process.env.NODE_ENV !== 'production') {
          var manualPropTypeCallCache = {};
          var manualPropTypeWarningCount = 0;
        }
        function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
          componentName = componentName || ANONYMOUS;
          propFullName = propFullName || propName;

          if (secret !== ReactPropTypesSecret_1) {
            if (throwOnDirectAccess) {
              // New behavior only for users of `prop-types` package
              var err = new Error(
                'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
                'Use `PropTypes.checkPropTypes()` to call them. ' +
                'Read more at http://fb.me/use-check-prop-types'
              );
              err.name = 'Invariant Violation';
              throw err;
            } else if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
              // Old behavior for people using React.PropTypes
              var cacheKey = componentName + ':' + propName;
              if (
                !manualPropTypeCallCache[cacheKey] &&
                // Avoid spamming the console because they are often not actionable except for lib authors
                manualPropTypeWarningCount < 3
              ) {
                printWarning$1(
                  'You are manually calling a React.PropTypes validation ' +
                  'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
                  'and will throw in the standalone `prop-types` package. ' +
                  'You may be seeing this warning due to a third-party PropTypes ' +
                  'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
                );
                manualPropTypeCallCache[cacheKey] = true;
                manualPropTypeWarningCount++;
              }
            }
          }
          if (props[propName] == null) {
            if (isRequired) {
              if (props[propName] === null) {
                return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
              }
              return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
            }
            return null;
          } else {
            return validate(props, propName, componentName, location, propFullName);
          }
        }

        var chainedCheckType = checkType.bind(null, false);
        chainedCheckType.isRequired = checkType.bind(null, true);

        return chainedCheckType;
      }

      function createPrimitiveTypeChecker(expectedType) {
        function validate(props, propName, componentName, location, propFullName, secret) {
          var propValue = props[propName];
          var propType = getPropType(propValue);
          if (propType !== expectedType) {
            // `propValue` being instance of, say, date/regexp, pass the 'object'
            // check, but we can offer a more precise error message here rather than
            // 'of type `object`'.
            var preciseType = getPreciseType(propValue);

            return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
          }
          return null;
        }
        return createChainableTypeChecker(validate);
      }

      function createAnyTypeChecker() {
        return createChainableTypeChecker(emptyFunctionThatReturnsNull);
      }

      function createArrayOfTypeChecker(typeChecker) {
        function validate(props, propName, componentName, location, propFullName) {
          if (typeof typeChecker !== 'function') {
            return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
          }
          var propValue = props[propName];
          if (!Array.isArray(propValue)) {
            var propType = getPropType(propValue);
            return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
          }
          for (var i = 0; i < propValue.length; i++) {
            var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
            if (error instanceof Error) {
              return error;
            }
          }
          return null;
        }
        return createChainableTypeChecker(validate);
      }

      function createElementTypeChecker() {
        function validate(props, propName, componentName, location, propFullName) {
          var propValue = props[propName];
          if (!isValidElement(propValue)) {
            var propType = getPropType(propValue);
            return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
          }
          return null;
        }
        return createChainableTypeChecker(validate);
      }

      function createInstanceTypeChecker(expectedClass) {
        function validate(props, propName, componentName, location, propFullName) {
          if (!(props[propName] instanceof expectedClass)) {
            var expectedClassName = expectedClass.name || ANONYMOUS;
            var actualClassName = getClassName(props[propName]);
            return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
          }
          return null;
        }
        return createChainableTypeChecker(validate);
      }

      function createEnumTypeChecker(expectedValues) {
        if (!Array.isArray(expectedValues)) {
          process.env.NODE_ENV !== 'production' ? printWarning$1('Invalid argument supplied to oneOf, expected an instance of array.') : void 0;
          return emptyFunctionThatReturnsNull;
        }

        function validate(props, propName, componentName, location, propFullName) {
          var propValue = props[propName];
          for (var i = 0; i < expectedValues.length; i++) {
            if (is(propValue, expectedValues[i])) {
              return null;
            }
          }

          var valuesString = JSON.stringify(expectedValues);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + propValue + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
        }
        return createChainableTypeChecker(validate);
      }

      function createObjectOfTypeChecker(typeChecker) {
        function validate(props, propName, componentName, location, propFullName) {
          if (typeof typeChecker !== 'function') {
            return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
          }
          var propValue = props[propName];
          var propType = getPropType(propValue);
          if (propType !== 'object') {
            return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
          }
          for (var key in propValue) {
            if (propValue.hasOwnProperty(key)) {
              var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
              if (error instanceof Error) {
                return error;
              }
            }
          }
          return null;
        }
        return createChainableTypeChecker(validate);
      }

      function createUnionTypeChecker(arrayOfTypeCheckers) {
        if (!Array.isArray(arrayOfTypeCheckers)) {
          process.env.NODE_ENV !== 'production' ? printWarning$1('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
          return emptyFunctionThatReturnsNull;
        }

        for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
          var checker = arrayOfTypeCheckers[i];
          if (typeof checker !== 'function') {
            printWarning$1(
              'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
              'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
            );
            return emptyFunctionThatReturnsNull;
          }
        }

        function validate(props, propName, componentName, location, propFullName) {
          for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
            var checker = arrayOfTypeCheckers[i];
            if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
              return null;
            }
          }

          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
        }
        return createChainableTypeChecker(validate);
      }

      function createNodeChecker() {
        function validate(props, propName, componentName, location, propFullName) {
          if (!isNode(props[propName])) {
            return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
          }
          return null;
        }
        return createChainableTypeChecker(validate);
      }

      function createShapeTypeChecker(shapeTypes) {
        function validate(props, propName, componentName, location, propFullName) {
          var propValue = props[propName];
          var propType = getPropType(propValue);
          if (propType !== 'object') {
            return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
          }
          for (var key in shapeTypes) {
            var checker = shapeTypes[key];
            if (!checker) {
              continue;
            }
            var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
            if (error) {
              return error;
            }
          }
          return null;
        }
        return createChainableTypeChecker(validate);
      }

      function createStrictShapeTypeChecker(shapeTypes) {
        function validate(props, propName, componentName, location, propFullName) {
          var propValue = props[propName];
          var propType = getPropType(propValue);
          if (propType !== 'object') {
            return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
          }
          // We need to check all keys in case some are required but missing from
          // props.
          var allKeys = objectAssign({}, props[propName], shapeTypes);
          for (var key in allKeys) {
            var checker = shapeTypes[key];
            if (!checker) {
              return new PropTypeError(
                'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
                '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
                '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
              );
            }
            var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
            if (error) {
              return error;
            }
          }
          return null;
        }

        return createChainableTypeChecker(validate);
      }

      function isNode(propValue) {
        switch (typeof propValue) {
          case 'number':
          case 'string':
          case 'undefined':
            return true;
          case 'boolean':
            return !propValue;
          case 'object':
            if (Array.isArray(propValue)) {
              return propValue.every(isNode);
            }
            if (propValue === null || isValidElement(propValue)) {
              return true;
            }

            var iteratorFn = getIteratorFn(propValue);
            if (iteratorFn) {
              var iterator = iteratorFn.call(propValue);
              var step;
              if (iteratorFn !== propValue.entries) {
                while (!(step = iterator.next()).done) {
                  if (!isNode(step.value)) {
                    return false;
                  }
                }
              } else {
                // Iterator will provide entry [k,v] tuples rather than values.
                while (!(step = iterator.next()).done) {
                  var entry = step.value;
                  if (entry) {
                    if (!isNode(entry[1])) {
                      return false;
                    }
                  }
                }
              }
            } else {
              return false;
            }

            return true;
          default:
            return false;
        }
      }

      function isSymbol(propType, propValue) {
        // Native Symbol.
        if (propType === 'symbol') {
          return true;
        }

        // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
        if (propValue['@@toStringTag'] === 'Symbol') {
          return true;
        }

        // Fallback for non-spec compliant Symbols which are polyfilled.
        if (typeof Symbol === 'function' && propValue instanceof Symbol) {
          return true;
        }

        return false;
      }

      // Equivalent of `typeof` but with special handling for array and regexp.
      function getPropType(propValue) {
        var propType = typeof propValue;
        if (Array.isArray(propValue)) {
          return 'array';
        }
        if (propValue instanceof RegExp) {
          // Old webkits (at least until Android 4.0) return 'function' rather than
          // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
          // passes PropTypes.object.
          return 'object';
        }
        if (isSymbol(propType, propValue)) {
          return 'symbol';
        }
        return propType;
      }

      // This handles more types than `getPropType`. Only used for error messages.
      // See `createPrimitiveTypeChecker`.
      function getPreciseType(propValue) {
        if (typeof propValue === 'undefined' || propValue === null) {
          return '' + propValue;
        }
        var propType = getPropType(propValue);
        if (propType === 'object') {
          if (propValue instanceof Date) {
            return 'date';
          } else if (propValue instanceof RegExp) {
            return 'regexp';
          }
        }
        return propType;
      }

      // Returns a string that is postfixed to a warning about an invalid type.
      // For example, "undefined" or "of type array"
      function getPostfixForTypeWarning(value) {
        var type = getPreciseType(value);
        switch (type) {
          case 'array':
          case 'object':
            return 'an ' + type;
          case 'boolean':
          case 'date':
          case 'regexp':
            return 'a ' + type;
          default:
            return type;
        }
      }

      // Returns class name of the object, if any.
      function getClassName(propValue) {
        if (!propValue.constructor || !propValue.constructor.name) {
          return ANONYMOUS;
        }
        return propValue.constructor.name;
      }

      ReactPropTypes.checkPropTypes = checkPropTypes_1;
      ReactPropTypes.PropTypes = ReactPropTypes;

      return ReactPropTypes;
    };

    function emptyFunction() {}

    var factoryWithThrowingShims = function() {
      function shim(props, propName, componentName, location, propFullName, secret) {
        if (secret === ReactPropTypesSecret_1) {
          // It is still safe when called from React.
          return;
        }
        var err = new Error(
          'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
          'Use PropTypes.checkPropTypes() to call them. ' +
          'Read more at http://fb.me/use-check-prop-types'
        );
        err.name = 'Invariant Violation';
        throw err;
      }  shim.isRequired = shim;
      function getShim() {
        return shim;
      }  // Important!
      // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
      var ReactPropTypes = {
        array: shim,
        bool: shim,
        func: shim,
        number: shim,
        object: shim,
        string: shim,
        symbol: shim,

        any: shim,
        arrayOf: getShim,
        element: shim,
        instanceOf: getShim,
        node: shim,
        objectOf: getShim,
        oneOf: getShim,
        oneOfType: getShim,
        shape: getShim,
        exact: getShim
      };

      ReactPropTypes.checkPropTypes = emptyFunction;
      ReactPropTypes.PropTypes = ReactPropTypes;

      return ReactPropTypes;
    };

    var propTypes = createCommonjsModule(function (module) {
    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    if (process.env.NODE_ENV !== 'production') {
      var REACT_ELEMENT_TYPE = (typeof Symbol === 'function' &&
        Symbol.for &&
        Symbol.for('react.element')) ||
        0xeac7;

      var isValidElement = function(object) {
        return typeof object === 'object' &&
          object !== null &&
          object.$$typeof === REACT_ELEMENT_TYPE;
      };

      // By explicitly using `prop-types` you are opting into new development behavior.
      // http://fb.me/prop-types-in-prod
      var throwOnDirectAccess = true;
      module.exports = factoryWithTypeCheckers(isValidElement, throwOnDirectAccess);
    } else {
      // By explicitly using `prop-types` you are opting into new production behavior.
      // http://fb.me/prop-types-in-prod
      module.exports = factoryWithThrowingShims();
    }
    });

    var hasClass_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = hasClass;
    function hasClass(element, className) {
      if (element.classList) return !!className && element.classList.contains(className);else return (" " + (element.className.baseVal || element.className) + " ").indexOf(" " + className + " ") !== -1;
    }
    module.exports = exports["default"];
    });

    unwrapExports(hasClass_1);

    var addClass_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = addClass;



    var _hasClass2 = _interopRequireDefault(hasClass_1);

    function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function addClass(element, className) {
      if (element.classList) element.classList.add(className);else if (!(0, _hasClass2.default)(element, className)) if (typeof element.className === 'string') element.className = element.className + ' ' + className;else element.setAttribute('class', (element.className && element.className.baseVal || '') + ' ' + className);
    }
    module.exports = exports['default'];
    });

    unwrapExports(addClass_1);

    function replaceClassName(origClass, classToRemove) {
      return origClass.replace(new RegExp('(^|\\s)' + classToRemove + '(?:\\s|$)', 'g'), '$1').replace(/\s+/g, ' ').replace(/^\s*|\s*$/g, '');
    }

    var removeClass = function removeClass(element, className) {
      if (element.classList) element.classList.remove(className);else if (typeof element.className === 'string') element.className = replaceClassName(element.className, className);else element.setAttribute('class', replaceClassName(element.className && element.className.baseVal || '', className));
    };

    var reactLifecyclesCompat_cjs = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, '__esModule', { value: true });

    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    function componentWillMount() {
      // Call this.constructor.gDSFP to support sub-classes.
      var state = this.constructor.getDerivedStateFromProps(this.props, this.state);
      if (state !== null && state !== undefined) {
        this.setState(state);
      }
    }

    function componentWillReceiveProps(nextProps) {
      // Call this.constructor.gDSFP to support sub-classes.
      // Use the setState() updater to ensure state isn't stale in certain edge cases.
      function updater(prevState) {
        var state = this.constructor.getDerivedStateFromProps(nextProps, prevState);
        return state !== null && state !== undefined ? state : null;
      }
      // Binding "this" is important for shallow renderer support.
      this.setState(updater.bind(this));
    }

    function componentWillUpdate(nextProps, nextState) {
      try {
        var prevProps = this.props;
        var prevState = this.state;
        this.props = nextProps;
        this.state = nextState;
        this.__reactInternalSnapshotFlag = true;
        this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(
          prevProps,
          prevState
        );
      } finally {
        this.props = prevProps;
        this.state = prevState;
      }
    }

    // React may warn about cWM/cWRP/cWU methods being deprecated.
    // Add a flag to suppress these warnings for this special case.
    componentWillMount.__suppressDeprecationWarning = true;
    componentWillReceiveProps.__suppressDeprecationWarning = true;
    componentWillUpdate.__suppressDeprecationWarning = true;

    function polyfill(Component) {
      var prototype = Component.prototype;

      if (!prototype || !prototype.isReactComponent) {
        throw new Error('Can only polyfill class components');
      }

      if (
        typeof Component.getDerivedStateFromProps !== 'function' &&
        typeof prototype.getSnapshotBeforeUpdate !== 'function'
      ) {
        return Component;
      }

      // If new component APIs are defined, "unsafe" lifecycles won't be called.
      // Error if any of these lifecycles are present,
      // Because they would work differently between older and newer (16.3+) versions of React.
      var foundWillMountName = null;
      var foundWillReceivePropsName = null;
      var foundWillUpdateName = null;
      if (typeof prototype.componentWillMount === 'function') {
        foundWillMountName = 'componentWillMount';
      } else if (typeof prototype.UNSAFE_componentWillMount === 'function') {
        foundWillMountName = 'UNSAFE_componentWillMount';
      }
      if (typeof prototype.componentWillReceiveProps === 'function') {
        foundWillReceivePropsName = 'componentWillReceiveProps';
      } else if (typeof prototype.UNSAFE_componentWillReceiveProps === 'function') {
        foundWillReceivePropsName = 'UNSAFE_componentWillReceiveProps';
      }
      if (typeof prototype.componentWillUpdate === 'function') {
        foundWillUpdateName = 'componentWillUpdate';
      } else if (typeof prototype.UNSAFE_componentWillUpdate === 'function') {
        foundWillUpdateName = 'UNSAFE_componentWillUpdate';
      }
      if (
        foundWillMountName !== null ||
        foundWillReceivePropsName !== null ||
        foundWillUpdateName !== null
      ) {
        var componentName = Component.displayName || Component.name;
        var newApiName =
          typeof Component.getDerivedStateFromProps === 'function'
            ? 'getDerivedStateFromProps()'
            : 'getSnapshotBeforeUpdate()';

        throw Error(
          'Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n' +
            componentName +
            ' uses ' +
            newApiName +
            ' but also contains the following legacy lifecycles:' +
            (foundWillMountName !== null ? '\n  ' + foundWillMountName : '') +
            (foundWillReceivePropsName !== null
              ? '\n  ' + foundWillReceivePropsName
              : '') +
            (foundWillUpdateName !== null ? '\n  ' + foundWillUpdateName : '') +
            '\n\nThe above lifecycles should be removed. Learn more about this warning here:\n' +
            'https://fb.me/react-async-component-lifecycle-hooks'
        );
      }

      // React <= 16.2 does not support static getDerivedStateFromProps.
      // As a workaround, use cWM and cWRP to invoke the new static lifecycle.
      // Newer versions of React will ignore these lifecycles if gDSFP exists.
      if (typeof Component.getDerivedStateFromProps === 'function') {
        prototype.componentWillMount = componentWillMount;
        prototype.componentWillReceiveProps = componentWillReceiveProps;
      }

      // React <= 16.2 does not support getSnapshotBeforeUpdate.
      // As a workaround, use cWU to invoke the new lifecycle.
      // Newer versions of React will ignore that lifecycle if gSBU exists.
      if (typeof prototype.getSnapshotBeforeUpdate === 'function') {
        if (typeof prototype.componentDidUpdate !== 'function') {
          throw new Error(
            'Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype'
          );
        }

        prototype.componentWillUpdate = componentWillUpdate;

        var componentDidUpdate = prototype.componentDidUpdate;

        prototype.componentDidUpdate = function componentDidUpdatePolyfill(
          prevProps,
          prevState,
          maybeSnapshot
        ) {
          // 16.3+ will not execute our will-update method;
          // It will pass a snapshot value to did-update though.
          // Older versions will require our polyfilled will-update value.
          // We need to handle both cases, but can't just check for the presence of "maybeSnapshot",
          // Because for <= 15.x versions this might be a "prevContext" object.
          // We also can't just check "__reactInternalSnapshot",
          // Because get-snapshot might return a falsy value.
          // So check for the explicit __reactInternalSnapshotFlag flag to determine behavior.
          var snapshot = this.__reactInternalSnapshotFlag
            ? this.__reactInternalSnapshot
            : maybeSnapshot;

          componentDidUpdate.call(this, prevProps, prevState, snapshot);
        };
      }

      return Component;
    }

    exports.polyfill = polyfill;
    });

    unwrapExports(reactLifecyclesCompat_cjs);
    var reactLifecyclesCompat_cjs_1 = reactLifecyclesCompat_cjs.polyfill;

    var PropTypes = createCommonjsModule(function (module, exports) {

    exports.__esModule = true;
    exports.classNamesShape = exports.timeoutsShape = undefined;
    exports.transitionTimeout = transitionTimeout;



    var _propTypes2 = _interopRequireDefault(propTypes);

    function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function transitionTimeout(transitionType) {
      var timeoutPropName = 'transition' + transitionType + 'Timeout';
      var enabledPropName = 'transition' + transitionType;

      return function (props) {
        // If the transition is enabled
        if (props[enabledPropName]) {
          // If no timeout duration is provided
          if (props[timeoutPropName] == null) {
            return new Error(timeoutPropName + ' wasn\'t supplied to CSSTransitionGroup: ' + 'this can cause unreliable animations and won\'t be supported in ' + 'a future version of React. See ' + 'https://fb.me/react-animation-transition-group-timeout for more ' + 'information.');

            // If the duration isn't a number
          } else if (typeof props[timeoutPropName] !== 'number') {
            return new Error(timeoutPropName + ' must be a number (in milliseconds)');
          }
        }

        return null;
      };
    }

    var timeoutsShape = exports.timeoutsShape = _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.shape({
      enter: _propTypes2.default.number,
      exit: _propTypes2.default.number
    }).isRequired]);

    var classNamesShape = exports.classNamesShape = _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.shape({
      enter: _propTypes2.default.string,
      exit: _propTypes2.default.string,
      active: _propTypes2.default.string
    }), _propTypes2.default.shape({
      enter: _propTypes2.default.string,
      enterDone: _propTypes2.default.string,
      enterActive: _propTypes2.default.string,
      exit: _propTypes2.default.string,
      exitDone: _propTypes2.default.string,
      exitActive: _propTypes2.default.string
    })]);
    });

    unwrapExports(PropTypes);
    var PropTypes_1 = PropTypes.classNamesShape;
    var PropTypes_2 = PropTypes.timeoutsShape;
    var PropTypes_3 = PropTypes.transitionTimeout;

    var Transition_1 = createCommonjsModule(function (module, exports) {

    exports.__esModule = true;
    exports.EXITING = exports.ENTERED = exports.ENTERING = exports.EXITED = exports.UNMOUNTED = undefined;



    var PropTypes$$1 = _interopRequireWildcard(propTypes);



    var _react2 = _interopRequireDefault(React__default);



    var _reactDom2 = _interopRequireDefault(reactDom);





    function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

    function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

    function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

    function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

    function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

    var UNMOUNTED = exports.UNMOUNTED = 'unmounted';
    var EXITED = exports.EXITED = 'exited';
    var ENTERING = exports.ENTERING = 'entering';
    var ENTERED = exports.ENTERED = 'entered';
    var EXITING = exports.EXITING = 'exiting';

    /**
     * The Transition component lets you describe a transition from one component
     * state to another _over time_ with a simple declarative API. Most commonly
     * it's used to animate the mounting and unmounting of a component, but can also
     * be used to describe in-place transition states as well.
     *
     * By default the `Transition` component does not alter the behavior of the
     * component it renders, it only tracks "enter" and "exit" states for the components.
     * It's up to you to give meaning and effect to those states. For example we can
     * add styles to a component when it enters or exits:
     *
     * ```jsx
     * import Transition from 'react-transition-group/Transition';
     *
     * const duration = 300;
     *
     * const defaultStyle = {
     *   transition: `opacity ${duration}ms ease-in-out`,
     *   opacity: 0,
     * }
     *
     * const transitionStyles = {
     *   entering: { opacity: 0 },
     *   entered:  { opacity: 1 },
     * };
     *
     * const Fade = ({ in: inProp }) => (
     *   <Transition in={inProp} timeout={duration}>
     *     {(state) => (
     *       <div style={{
     *         ...defaultStyle,
     *         ...transitionStyles[state]
     *       }}>
     *         I'm a fade Transition!
     *       </div>
     *     )}
     *   </Transition>
     * );
     * ```
     *
     * As noted the `Transition` component doesn't _do_ anything by itself to its child component.
     * What it does do is track transition states over time so you can update the
     * component (such as by adding styles or classes) when it changes states.
     *
     * There are 4 main states a Transition can be in:
     *  - `'entering'`
     *  - `'entered'`
     *  - `'exiting'`
     *  - `'exited'`
     *
     * Transition state is toggled via the `in` prop. When `true` the component begins the
     * "Enter" stage. During this stage, the component will shift from its current transition state,
     * to `'entering'` for the duration of the transition and then to the `'entered'` stage once
     * it's complete. Let's take the following example:
     *
     * ```jsx
     * state = { in: false };
     *
     * toggleEnterState = () => {
     *   this.setState({ in: true });
     * }
     *
     * render() {
     *   return (
     *     <div>
     *       <Transition in={this.state.in} timeout={500} />
     *       <button onClick={this.toggleEnterState}>Click to Enter</button>
     *     </div>
     *   );
     * }
     * ```
     *
     * When the button is clicked the component will shift to the `'entering'` state and
     * stay there for 500ms (the value of `timeout`) before it finally switches to `'entered'`.
     *
     * When `in` is `false` the same thing happens except the state moves from `'exiting'` to `'exited'`.
     *
     * ## Timing
     *
     * Timing is often the trickiest part of animation, mistakes can result in slight delays
     * that are hard to pin down. A common example is when you want to add an exit transition,
     * you should set the desired final styles when the state is `'exiting'`. That's when the
     * transition to those styles will start and, if you matched the `timeout` prop with the
     * CSS Transition duration, it will end exactly when the state changes to `'exited'`.
     *
     * > **Note**: For simpler transitions the `Transition` component might be enough, but
     * > take into account that it's platform-agnostic, while the `CSSTransition` component
     * > [forces reflows](https://github.com/reactjs/react-transition-group/blob/5007303e729a74be66a21c3e2205e4916821524b/src/CSSTransition.js#L208-L215)
     * > in order to make more complex transitions more predictable. For example, even though
     * > classes `example-enter` and `example-enter-active` are applied immediately one after
     * > another, you can still transition from one to the other because of the forced reflow
     * > (read [this issue](https://github.com/reactjs/react-transition-group/issues/159#issuecomment-322761171)
     * > for more info). Take this into account when choosing between `Transition` and
     * > `CSSTransition`.
     *
     * ## Example
     *
     * <iframe src="https://codesandbox.io/embed/741op4mmj0?fontsize=14" style="width:100%; height:500px; border:0; border-radius: 4px; overflow:hidden;" sandbox="allow-modals allow-forms allow-popups allow-scripts allow-same-origin"></iframe>
     *
     */

    var Transition = function (_React$Component) {
      _inherits(Transition, _React$Component);

      function Transition(props, context) {
        _classCallCheck(this, Transition);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props, context));

        var parentGroup = context.transitionGroup;
        // In the context of a TransitionGroup all enters are really appears
        var appear = parentGroup && !parentGroup.isMounting ? props.enter : props.appear;

        var initialStatus = void 0;

        _this.appearStatus = null;

        if (props.in) {
          if (appear) {
            initialStatus = EXITED;
            _this.appearStatus = ENTERING;
          } else {
            initialStatus = ENTERED;
          }
        } else {
          if (props.unmountOnExit || props.mountOnEnter) {
            initialStatus = UNMOUNTED;
          } else {
            initialStatus = EXITED;
          }
        }

        _this.state = { status: initialStatus };

        _this.nextCallback = null;
        return _this;
      }

      Transition.prototype.getChildContext = function getChildContext() {
        return { transitionGroup: null // allows for nested Transitions
        };
      };

      Transition.getDerivedStateFromProps = function getDerivedStateFromProps(_ref, prevState) {
        var nextIn = _ref.in;

        if (nextIn && prevState.status === UNMOUNTED) {
          return { status: EXITED };
        }
        return null;
      };

      // getSnapshotBeforeUpdate(prevProps) {
      //   let nextStatus = null

      //   if (prevProps !== this.props) {
      //     const { status } = this.state

      //     if (this.props.in) {
      //       if (status !== ENTERING && status !== ENTERED) {
      //         nextStatus = ENTERING
      //       }
      //     } else {
      //       if (status === ENTERING || status === ENTERED) {
      //         nextStatus = EXITING
      //       }
      //     }
      //   }

      //   return { nextStatus }
      // }

      Transition.prototype.componentDidMount = function componentDidMount() {
        this.updateStatus(true, this.appearStatus);
      };

      Transition.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
        var nextStatus = null;
        if (prevProps !== this.props) {
          var status = this.state.status;


          if (this.props.in) {
            if (status !== ENTERING && status !== ENTERED) {
              nextStatus = ENTERING;
            }
          } else {
            if (status === ENTERING || status === ENTERED) {
              nextStatus = EXITING;
            }
          }
        }
        this.updateStatus(false, nextStatus);
      };

      Transition.prototype.componentWillUnmount = function componentWillUnmount() {
        this.cancelNextCallback();
      };

      Transition.prototype.getTimeouts = function getTimeouts() {
        var timeout = this.props.timeout;

        var exit = void 0,
            enter = void 0,
            appear = void 0;

        exit = enter = appear = timeout;

        if (timeout != null && typeof timeout !== 'number') {
          exit = timeout.exit;
          enter = timeout.enter;
          appear = timeout.appear;
        }
        return { exit: exit, enter: enter, appear: appear };
      };

      Transition.prototype.updateStatus = function updateStatus() {
        var mounting = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
        var nextStatus = arguments[1];

        if (nextStatus !== null) {
          // nextStatus will always be ENTERING or EXITING.
          this.cancelNextCallback();
          var node = _reactDom2.default.findDOMNode(this);

          if (nextStatus === ENTERING) {
            this.performEnter(node, mounting);
          } else {
            this.performExit(node);
          }
        } else if (this.props.unmountOnExit && this.state.status === EXITED) {
          this.setState({ status: UNMOUNTED });
        }
      };

      Transition.prototype.performEnter = function performEnter(node, mounting) {
        var _this2 = this;

        var enter = this.props.enter;

        var appearing = this.context.transitionGroup ? this.context.transitionGroup.isMounting : mounting;

        var timeouts = this.getTimeouts();

        // no enter animation skip right to ENTERED
        // if we are mounting and running this it means appear _must_ be set
        if (!mounting && !enter) {
          this.safeSetState({ status: ENTERED }, function () {
            _this2.props.onEntered(node);
          });
          return;
        }

        this.props.onEnter(node, appearing);

        this.safeSetState({ status: ENTERING }, function () {
          _this2.props.onEntering(node, appearing);

          // FIXME: appear timeout?
          _this2.onTransitionEnd(node, timeouts.enter, function () {
            _this2.safeSetState({ status: ENTERED }, function () {
              _this2.props.onEntered(node, appearing);
            });
          });
        });
      };

      Transition.prototype.performExit = function performExit(node) {
        var _this3 = this;

        var exit = this.props.exit;

        var timeouts = this.getTimeouts();

        // no exit animation skip right to EXITED
        if (!exit) {
          this.safeSetState({ status: EXITED }, function () {
            _this3.props.onExited(node);
          });
          return;
        }
        this.props.onExit(node);

        this.safeSetState({ status: EXITING }, function () {
          _this3.props.onExiting(node);

          _this3.onTransitionEnd(node, timeouts.exit, function () {
            _this3.safeSetState({ status: EXITED }, function () {
              _this3.props.onExited(node);
            });
          });
        });
      };

      Transition.prototype.cancelNextCallback = function cancelNextCallback() {
        if (this.nextCallback !== null) {
          this.nextCallback.cancel();
          this.nextCallback = null;
        }
      };

      Transition.prototype.safeSetState = function safeSetState(nextState, callback) {
        // This shouldn't be necessary, but there are weird race conditions with
        // setState callbacks and unmounting in testing, so always make sure that
        // we can cancel any pending setState callbacks after we unmount.
        callback = this.setNextCallback(callback);
        this.setState(nextState, callback);
      };

      Transition.prototype.setNextCallback = function setNextCallback(callback) {
        var _this4 = this;

        var active = true;

        this.nextCallback = function (event) {
          if (active) {
            active = false;
            _this4.nextCallback = null;

            callback(event);
          }
        };

        this.nextCallback.cancel = function () {
          active = false;
        };

        return this.nextCallback;
      };

      Transition.prototype.onTransitionEnd = function onTransitionEnd(node, timeout, handler) {
        this.setNextCallback(handler);

        if (node) {
          if (this.props.addEndListener) {
            this.props.addEndListener(node, this.nextCallback);
          }
          if (timeout != null) {
            setTimeout(this.nextCallback, timeout);
          }
        } else {
          setTimeout(this.nextCallback, 0);
        }
      };

      Transition.prototype.render = function render() {
        var status = this.state.status;
        if (status === UNMOUNTED) {
          return null;
        }

        var _props = this.props,
            children = _props.children,
            childProps = _objectWithoutProperties(_props, ['children']);
        // filter props for Transtition


        delete childProps.in;
        delete childProps.mountOnEnter;
        delete childProps.unmountOnExit;
        delete childProps.appear;
        delete childProps.enter;
        delete childProps.exit;
        delete childProps.timeout;
        delete childProps.addEndListener;
        delete childProps.onEnter;
        delete childProps.onEntering;
        delete childProps.onEntered;
        delete childProps.onExit;
        delete childProps.onExiting;
        delete childProps.onExited;

        if (typeof children === 'function') {
          return children(status, childProps);
        }

        var child = _react2.default.Children.only(children);
        return _react2.default.cloneElement(child, childProps);
      };

      return Transition;
    }(_react2.default.Component);

    Transition.contextTypes = {
      transitionGroup: PropTypes$$1.object
    };
    Transition.childContextTypes = {
      transitionGroup: function transitionGroup() {}
    };


    Transition.propTypes = process.env.NODE_ENV !== "production" ? {
      /**
       * A `function` child can be used instead of a React element.
       * This function is called with the current transition status
       * ('entering', 'entered', 'exiting', 'exited', 'unmounted'), which can be used
       * to apply context specific props to a component.
       *
       * ```jsx
       * <Transition timeout={150}>
       *   {(status) => (
       *     <MyComponent className={`fade fade-${status}`} />
       *   )}
       * </Transition>
       * ```
       */
      children: PropTypes$$1.oneOfType([PropTypes$$1.func.isRequired, PropTypes$$1.element.isRequired]).isRequired,

      /**
       * Show the component; triggers the enter or exit states
       */
      in: PropTypes$$1.bool,

      /**
       * By default the child component is mounted immediately along with
       * the parent `Transition` component. If you want to "lazy mount" the component on the
       * first `in={true}` you can set `mountOnEnter`. After the first enter transition the component will stay
       * mounted, even on "exited", unless you also specify `unmountOnExit`.
       */
      mountOnEnter: PropTypes$$1.bool,

      /**
       * By default the child component stays mounted after it reaches the `'exited'` state.
       * Set `unmountOnExit` if you'd prefer to unmount the component after it finishes exiting.
       */
      unmountOnExit: PropTypes$$1.bool,

      /**
       * Normally a component is not transitioned if it is shown when the `<Transition>` component mounts.
       * If you want to transition on the first mount set `appear` to `true`, and the
       * component will transition in as soon as the `<Transition>` mounts.
       *
       * > Note: there are no specific "appear" states. `appear` only adds an additional `enter` transition.
       */
      appear: PropTypes$$1.bool,

      /**
       * Enable or disable enter transitions.
       */
      enter: PropTypes$$1.bool,

      /**
       * Enable or disable exit transitions.
       */
      exit: PropTypes$$1.bool,

      /**
       * The duration of the transition, in milliseconds.
       * Required unless `addEndListener` is provided
       *
       * You may specify a single timeout for all transitions like: `timeout={500}`,
       * or individually like:
       *
       * ```jsx
       * timeout={{
       *  enter: 300,
       *  exit: 500,
       * }}
       * ```
       *
       * @type {number | { enter?: number, exit?: number }}
       */
      timeout: function timeout(props) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        var pt = PropTypes.timeoutsShape;
        if (!props.addEndListener) pt = pt.isRequired;
        return pt.apply(undefined, [props].concat(args));
      },

      /**
       * Add a custom transition end trigger. Called with the transitioning
       * DOM node and a `done` callback. Allows for more fine grained transition end
       * logic. **Note:** Timeouts are still used as a fallback if provided.
       *
       * ```jsx
       * addEndListener={(node, done) => {
       *   // use the css transitionend event to mark the finish of a transition
       *   node.addEventListener('transitionend', done, false);
       * }}
       * ```
       */
      addEndListener: PropTypes$$1.func,

      /**
       * Callback fired before the "entering" status is applied. An extra parameter
       * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
       *
       * @type Function(node: HtmlElement, isAppearing: bool) -> void
       */
      onEnter: PropTypes$$1.func,

      /**
       * Callback fired after the "entering" status is applied. An extra parameter
       * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEntering: PropTypes$$1.func,

      /**
       * Callback fired after the "entered" status is applied. An extra parameter
       * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
       *
       * @type Function(node: HtmlElement, isAppearing: bool) -> void
       */
      onEntered: PropTypes$$1.func,

      /**
       * Callback fired before the "exiting" status is applied.
       *
       * @type Function(node: HtmlElement) -> void
       */
      onExit: PropTypes$$1.func,

      /**
       * Callback fired after the "exiting" status is applied.
       *
       * @type Function(node: HtmlElement) -> void
       */
      onExiting: PropTypes$$1.func,

      /**
       * Callback fired after the "exited" status is applied.
       *
       * @type Function(node: HtmlElement) -> void
       */
      onExited: PropTypes$$1.func

      // Name the function so it is clearer in the documentation
    } : {};function noop() {}

    Transition.defaultProps = {
      in: false,
      mountOnEnter: false,
      unmountOnExit: false,
      appear: false,
      enter: true,
      exit: true,

      onEnter: noop,
      onEntering: noop,
      onEntered: noop,

      onExit: noop,
      onExiting: noop,
      onExited: noop
    };

    Transition.UNMOUNTED = 0;
    Transition.EXITED = 1;
    Transition.ENTERING = 2;
    Transition.ENTERED = 3;
    Transition.EXITING = 4;

    exports.default = (0, reactLifecyclesCompat_cjs.polyfill)(Transition);
    });

    unwrapExports(Transition_1);
    var Transition_2 = Transition_1.EXITING;
    var Transition_3 = Transition_1.ENTERED;
    var Transition_4 = Transition_1.ENTERING;
    var Transition_5 = Transition_1.EXITED;
    var Transition_6 = Transition_1.UNMOUNTED;

    var CSSTransition_1 = createCommonjsModule(function (module, exports) {

    exports.__esModule = true;

    var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };



    var PropTypes$$1 = _interopRequireWildcard(propTypes);



    var _addClass2 = _interopRequireDefault(addClass_1);



    var _removeClass2 = _interopRequireDefault(removeClass);



    var _react2 = _interopRequireDefault(React__default);



    var _Transition2 = _interopRequireDefault(Transition_1);



    function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

    function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

    function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

    function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

    var addClass = function addClass(node, classes) {
      return node && classes && classes.split(' ').forEach(function (c) {
        return (0, _addClass2.default)(node, c);
      });
    };
    var removeClass$$1 = function removeClass$$1(node, classes) {
      return node && classes && classes.split(' ').forEach(function (c) {
        return (0, _removeClass2.default)(node, c);
      });
    };

    var propTypes$$1 = _extends({}, _Transition2.default.propTypes, {

      /**
       * The animation classNames applied to the component as it enters, exits or has finished the transition.
       * A single name can be provided and it will be suffixed for each stage: e.g.
       *
       * `classNames="fade"` applies `fade-enter`, `fade-enter-active`, `fade-enter-done`,
       * `fade-exit`, `fade-exit-active`, `fade-exit-done`, `fade-appear`, and `fade-appear-active`.
       * Each individual classNames can also be specified independently like:
       *
       * ```js
       * classNames={{
       *  appear: 'my-appear',
       *  appearActive: 'my-active-appear',
       *  enter: 'my-enter',
       *  enterActive: 'my-active-enter',
       *  enterDone: 'my-done-enter',
       *  exit: 'my-exit',
       *  exitActive: 'my-active-exit',
       *  exitDone: 'my-done-exit',
       * }}
       * ```
       *
       * If you want to set these classes using CSS Modules:
       *
       * ```js
       * import styles from './styles.css';
       * ```
       *
       * you might want to use camelCase in your CSS file, that way could simply spread
       * them instead of listing them one by one:
       *
       * ```js
       * classNames={{ ...styles }}
       * ```
       *
       * @type {string | {
       *  appear?: string,
       *  appearActive?: string,
       *  enter?: string,
       *  enterActive?: string,
       *  enterDone?: string,
       *  exit?: string,
       *  exitActive?: string,
       *  exitDone?: string,
       * }}
       */
      classNames: PropTypes.classNamesShape,

      /**
       * A `<Transition>` callback fired immediately after the 'enter' or 'appear' class is
       * applied.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEnter: PropTypes$$1.func,

      /**
       * A `<Transition>` callback fired immediately after the 'enter-active' or
       * 'appear-active' class is applied.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEntering: PropTypes$$1.func,

      /**
       * A `<Transition>` callback fired immediately after the 'enter' or
       * 'appear' classes are **removed** and the `done` class is added to the DOM node.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEntered: PropTypes$$1.func,

      /**
       * A `<Transition>` callback fired immediately after the 'exit' class is
       * applied.
       *
       * @type Function(node: HtmlElement)
       */
      onExit: PropTypes$$1.func,

      /**
       * A `<Transition>` callback fired immediately after the 'exit-active' is applied.
       *
       * @type Function(node: HtmlElement
       */
      onExiting: PropTypes$$1.func,

      /**
       * A `<Transition>` callback fired immediately after the 'exit' classes
       * are **removed** and the `exit-done` class is added to the DOM node.
       *
       * @type Function(node: HtmlElement)
       */
      onExited: PropTypes$$1.func
    });

    /**
     * A `Transition` component using CSS transitions and animations.
     * It's inspired by the excellent [ng-animate](http://www.nganimate.org/) library.
     *
     * `CSSTransition` applies a pair of class names during the `appear`, `enter`,
     * and `exit` stages of the transition. The first class is applied and then a
     * second "active" class in order to activate the css animation. After the animation,
     * matching `done` class names are applied to persist the animation state.
     *
     * When the `in` prop is toggled to `true` the Component will get
     * the `example-enter` CSS class and the `example-enter-active` CSS class
     * added in the next tick. This is a convention based on the `classNames` prop.
     *
     * ## Example
     *
     * <iframe src="https://codesandbox.io/embed/m77l2vp00x?fontsize=14" style="width:100%; height:500px; border:0; border-radius: 4px; overflow:hidden;" sandbox="allow-modals allow-forms allow-popups allow-scripts allow-same-origin"></iframe>
     */

    var CSSTransition = function (_React$Component) {
      _inherits(CSSTransition, _React$Component);

      function CSSTransition() {
        var _temp, _this, _ret;

        _classCallCheck(this, CSSTransition);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.onEnter = function (node, appearing) {
          var _this$getClassNames = _this.getClassNames(appearing ? 'appear' : 'enter'),
              className = _this$getClassNames.className;

          _this.removeClasses(node, 'exit');
          addClass(node, className);

          if (_this.props.onEnter) {
            _this.props.onEnter(node);
          }
        }, _this.onEntering = function (node, appearing) {
          var _this$getClassNames2 = _this.getClassNames(appearing ? 'appear' : 'enter'),
              activeClassName = _this$getClassNames2.activeClassName;

          _this.reflowAndAddClass(node, activeClassName);

          if (_this.props.onEntering) {
            _this.props.onEntering(node);
          }
        }, _this.onEntered = function (node, appearing) {
          var _this$getClassNames3 = _this.getClassNames('enter'),
              doneClassName = _this$getClassNames3.doneClassName;

          _this.removeClasses(node, appearing ? 'appear' : 'enter');
          addClass(node, doneClassName);

          if (_this.props.onEntered) {
            _this.props.onEntered(node);
          }
        }, _this.onExit = function (node) {
          var _this$getClassNames4 = _this.getClassNames('exit'),
              className = _this$getClassNames4.className;

          _this.removeClasses(node, 'appear');
          _this.removeClasses(node, 'enter');
          addClass(node, className);

          if (_this.props.onExit) {
            _this.props.onExit(node);
          }
        }, _this.onExiting = function (node) {
          var _this$getClassNames5 = _this.getClassNames('exit'),
              activeClassName = _this$getClassNames5.activeClassName;

          _this.reflowAndAddClass(node, activeClassName);

          if (_this.props.onExiting) {
            _this.props.onExiting(node);
          }
        }, _this.onExited = function (node) {
          var _this$getClassNames6 = _this.getClassNames('exit'),
              doneClassName = _this$getClassNames6.doneClassName;

          _this.removeClasses(node, 'exit');
          addClass(node, doneClassName);

          if (_this.props.onExited) {
            _this.props.onExited(node);
          }
        }, _this.getClassNames = function (type) {
          var classNames = _this.props.classNames;


          var className = typeof classNames !== 'string' ? classNames[type] : classNames + '-' + type;

          var activeClassName = typeof classNames !== 'string' ? classNames[type + 'Active'] : className + '-active';

          var doneClassName = typeof classNames !== 'string' ? classNames[type + 'Done'] : className + '-done';

          return {
            className: className,
            activeClassName: activeClassName,
            doneClassName: doneClassName
          };
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      CSSTransition.prototype.removeClasses = function removeClasses(node, type) {
        var _getClassNames = this.getClassNames(type),
            className = _getClassNames.className,
            activeClassName = _getClassNames.activeClassName,
            doneClassName = _getClassNames.doneClassName;

        className && removeClass$$1(node, className);
        activeClassName && removeClass$$1(node, activeClassName);
        doneClassName && removeClass$$1(node, doneClassName);
      };

      CSSTransition.prototype.reflowAndAddClass = function reflowAndAddClass(node, className) {
        // This is for to force a repaint,
        // which is necessary in order to transition styles when adding a class name.
        if (className) {
          /* eslint-disable no-unused-expressions */
          node && node.scrollTop;
          /* eslint-enable no-unused-expressions */
          addClass(node, className);
        }
      };

      CSSTransition.prototype.render = function render() {
        var props = _extends({}, this.props);

        delete props.classNames;

        return _react2.default.createElement(_Transition2.default, _extends({}, props, {
          onEnter: this.onEnter,
          onEntered: this.onEntered,
          onEntering: this.onEntering,
          onExit: this.onExit,
          onExiting: this.onExiting,
          onExited: this.onExited
        }));
      };

      return CSSTransition;
    }(_react2.default.Component);

    CSSTransition.propTypes = process.env.NODE_ENV !== "production" ? propTypes$$1 : {};

    exports.default = CSSTransition;
    module.exports = exports['default'];
    });

    unwrapExports(CSSTransition_1);

    var ChildMapping = createCommonjsModule(function (module, exports) {

    exports.__esModule = true;
    exports.getChildMapping = getChildMapping;
    exports.mergeChildMappings = mergeChildMappings;
    exports.getInitialChildMapping = getInitialChildMapping;
    exports.getNextChildMapping = getNextChildMapping;



    /**
     * Given `this.props.children`, return an object mapping key to child.
     *
     * @param {*} children `this.props.children`
     * @return {object} Mapping of key to child
     */
    function getChildMapping(children, mapFn) {
      var mapper = function mapper(child) {
        return mapFn && (0, React__default.isValidElement)(child) ? mapFn(child) : child;
      };

      var result = Object.create(null);
      if (children) React__default.Children.map(children, function (c) {
        return c;
      }).forEach(function (child) {
        // run the map function here instead so that the key is the computed one
        result[child.key] = mapper(child);
      });
      return result;
    }

    /**
     * When you're adding or removing children some may be added or removed in the
     * same render pass. We want to show *both* since we want to simultaneously
     * animate elements in and out. This function takes a previous set of keys
     * and a new set of keys and merges them with its best guess of the correct
     * ordering. In the future we may expose some of the utilities in
     * ReactMultiChild to make this easy, but for now React itself does not
     * directly have this concept of the union of prevChildren and nextChildren
     * so we implement it here.
     *
     * @param {object} prev prev children as returned from
     * `ReactTransitionChildMapping.getChildMapping()`.
     * @param {object} next next children as returned from
     * `ReactTransitionChildMapping.getChildMapping()`.
     * @return {object} a key set that contains all keys in `prev` and all keys
     * in `next` in a reasonable order.
     */
    function mergeChildMappings(prev, next) {
      prev = prev || {};
      next = next || {};

      function getValueForKey(key) {
        return key in next ? next[key] : prev[key];
      }

      // For each key of `next`, the list of keys to insert before that key in
      // the combined list
      var nextKeysPending = Object.create(null);

      var pendingKeys = [];
      for (var prevKey in prev) {
        if (prevKey in next) {
          if (pendingKeys.length) {
            nextKeysPending[prevKey] = pendingKeys;
            pendingKeys = [];
          }
        } else {
          pendingKeys.push(prevKey);
        }
      }

      var i = void 0;
      var childMapping = {};
      for (var nextKey in next) {
        if (nextKeysPending[nextKey]) {
          for (i = 0; i < nextKeysPending[nextKey].length; i++) {
            var pendingNextKey = nextKeysPending[nextKey][i];
            childMapping[nextKeysPending[nextKey][i]] = getValueForKey(pendingNextKey);
          }
        }
        childMapping[nextKey] = getValueForKey(nextKey);
      }

      // Finally, add the keys which didn't appear before any key in `next`
      for (i = 0; i < pendingKeys.length; i++) {
        childMapping[pendingKeys[i]] = getValueForKey(pendingKeys[i]);
      }

      return childMapping;
    }

    function getProp(child, prop, props) {
      return props[prop] != null ? props[prop] : child.props[prop];
    }

    function getInitialChildMapping(props, onExited) {
      return getChildMapping(props.children, function (child) {
        return (0, React__default.cloneElement)(child, {
          onExited: onExited.bind(null, child),
          in: true,
          appear: getProp(child, 'appear', props),
          enter: getProp(child, 'enter', props),
          exit: getProp(child, 'exit', props)
        });
      });
    }

    function getNextChildMapping(nextProps, prevChildMapping, onExited) {
      var nextChildMapping = getChildMapping(nextProps.children);
      var children = mergeChildMappings(prevChildMapping, nextChildMapping);

      Object.keys(children).forEach(function (key) {
        var child = children[key];

        if (!(0, React__default.isValidElement)(child)) return;

        var hasPrev = key in prevChildMapping;
        var hasNext = key in nextChildMapping;

        var prevChild = prevChildMapping[key];
        var isLeaving = (0, React__default.isValidElement)(prevChild) && !prevChild.props.in;

        // item is new (entering)
        if (hasNext && (!hasPrev || isLeaving)) {
          // console.log('entering', key)
          children[key] = (0, React__default.cloneElement)(child, {
            onExited: onExited.bind(null, child),
            in: true,
            exit: getProp(child, 'exit', nextProps),
            enter: getProp(child, 'enter', nextProps)
          });
        } else if (!hasNext && hasPrev && !isLeaving) {
          // item is old (exiting)
          // console.log('leaving', key)
          children[key] = (0, React__default.cloneElement)(child, { in: false });
        } else if (hasNext && hasPrev && (0, React__default.isValidElement)(prevChild)) {
          // item hasn't changed transition states
          // copy over the last transition props;
          // console.log('unchanged', key)
          children[key] = (0, React__default.cloneElement)(child, {
            onExited: onExited.bind(null, child),
            in: prevChild.props.in,
            exit: getProp(child, 'exit', nextProps),
            enter: getProp(child, 'enter', nextProps)
          });
        }
      });

      return children;
    }
    });

    unwrapExports(ChildMapping);
    var ChildMapping_1 = ChildMapping.getChildMapping;
    var ChildMapping_2 = ChildMapping.mergeChildMappings;
    var ChildMapping_3 = ChildMapping.getInitialChildMapping;
    var ChildMapping_4 = ChildMapping.getNextChildMapping;

    var TransitionGroup_1 = createCommonjsModule(function (module, exports) {

    exports.__esModule = true;

    var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };



    var _propTypes2 = _interopRequireDefault(propTypes);



    var _react2 = _interopRequireDefault(React__default);





    function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

    function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

    function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

    function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

    var values = Object.values || function (obj) {
      return Object.keys(obj).map(function (k) {
        return obj[k];
      });
    };

    var propTypes$$1 = {
      /**
       * `<TransitionGroup>` renders a `<div>` by default. You can change this
       * behavior by providing a `component` prop.
       * If you use React v16+ and would like to avoid a wrapping `<div>` element
       * you can pass in `component={null}`. This is useful if the wrapping div
       * borks your css styles.
       */
      component: _propTypes2.default.any,
      /**
       * A set of `<Transition>` components, that are toggled `in` and out as they
       * leave. the `<TransitionGroup>` will inject specific transition props, so
       * remember to spread them through if you are wrapping the `<Transition>` as
       * with our `<Fade>` example.
       */
      children: _propTypes2.default.node,

      /**
       * A convenience prop that enables or disables appear animations
       * for all children. Note that specifying this will override any defaults set
       * on individual children Transitions.
       */
      appear: _propTypes2.default.bool,
      /**
       * A convenience prop that enables or disables enter animations
       * for all children. Note that specifying this will override any defaults set
       * on individual children Transitions.
       */
      enter: _propTypes2.default.bool,
      /**
       * A convenience prop that enables or disables exit animations
       * for all children. Note that specifying this will override any defaults set
       * on individual children Transitions.
       */
      exit: _propTypes2.default.bool,

      /**
       * You may need to apply reactive updates to a child as it is exiting.
       * This is generally done by using `cloneElement` however in the case of an exiting
       * child the element has already been removed and not accessible to the consumer.
       *
       * If you do need to update a child as it leaves you can provide a `childFactory`
       * to wrap every child, even the ones that are leaving.
       *
       * @type Function(child: ReactElement) -> ReactElement
       */
      childFactory: _propTypes2.default.func
    };

    var defaultProps = {
      component: 'div',
      childFactory: function childFactory(child) {
        return child;
      }

      /**
       * The `<TransitionGroup>` component manages a set of `<Transition>` components
       * in a list. Like with the `<Transition>` component, `<TransitionGroup>`, is a
       * state machine for managing the mounting and unmounting of components over
       * time.
       *
       * Consider the example below using the `Fade` CSS transition from before.
       * As items are removed or added to the TodoList the `in` prop is toggled
       * automatically by the `<TransitionGroup>`. You can use _any_ `<Transition>`
       * component in a `<TransitionGroup>`, not just css.
       *
       * ## Example
       *
       * <iframe src="https://codesandbox.io/embed/00rqyo26kn?fontsize=14" style="width:100%; height:500px; border:0; border-radius: 4px; overflow:hidden;" sandbox="allow-modals allow-forms allow-popups allow-scripts allow-same-origin"></iframe>
       *
       * Note that `<TransitionGroup>`  does not define any animation behavior!
       * Exactly _how_ a list item animates is up to the individual `<Transition>`
       * components. This means you can mix and match animations across different
       * list items.
       */
    };
    var TransitionGroup = function (_React$Component) {
      _inherits(TransitionGroup, _React$Component);

      function TransitionGroup(props, context) {
        _classCallCheck(this, TransitionGroup);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props, context));

        var handleExited = _this.handleExited.bind(_this);

        // Initial children should all be entering, dependent on appear
        _this.state = {
          handleExited: handleExited,
          firstRender: true
        };
        return _this;
      }

      TransitionGroup.prototype.getChildContext = function getChildContext() {
        return {
          transitionGroup: { isMounting: !this.appeared }
        };
      };

      TransitionGroup.prototype.componentDidMount = function componentDidMount() {
        this.appeared = true;
      };

      TransitionGroup.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, _ref) {
        var prevChildMapping = _ref.children,
            handleExited = _ref.handleExited,
            firstRender = _ref.firstRender;

        return {
          children: firstRender ? (0, ChildMapping.getInitialChildMapping)(nextProps, handleExited) : (0, ChildMapping.getNextChildMapping)(nextProps, prevChildMapping, handleExited),
          firstRender: false
        };
      };

      TransitionGroup.prototype.handleExited = function handleExited(child, node) {
        var currentChildMapping = (0, ChildMapping.getChildMapping)(this.props.children);

        if (child.key in currentChildMapping) return;

        if (child.props.onExited) {
          child.props.onExited(node);
        }

        this.setState(function (state) {
          var children = _extends({}, state.children);

          delete children[child.key];
          return { children: children };
        });
      };

      TransitionGroup.prototype.render = function render() {
        var _props = this.props,
            Component = _props.component,
            childFactory = _props.childFactory,
            props = _objectWithoutProperties(_props, ['component', 'childFactory']);

        var children = values(this.state.children).map(childFactory);

        delete props.appear;
        delete props.enter;
        delete props.exit;

        if (Component === null) {
          return children;
        }
        return _react2.default.createElement(
          Component,
          props,
          children
        );
      };

      return TransitionGroup;
    }(_react2.default.Component);

    TransitionGroup.childContextTypes = {
      transitionGroup: _propTypes2.default.object.isRequired
    };


    TransitionGroup.propTypes = process.env.NODE_ENV !== "production" ? propTypes$$1 : {};
    TransitionGroup.defaultProps = defaultProps;

    exports.default = (0, reactLifecyclesCompat_cjs.polyfill)(TransitionGroup);
    module.exports = exports['default'];
    });

    unwrapExports(TransitionGroup_1);

    var ReplaceTransition_1 = createCommonjsModule(function (module, exports) {

    exports.__esModule = true;



    var _propTypes2 = _interopRequireDefault(propTypes);



    var _react2 = _interopRequireDefault(React__default);





    var _TransitionGroup2 = _interopRequireDefault(TransitionGroup_1);

    function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

    function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

    function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

    function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

    var propTypes$$1 = {
      in: _propTypes2.default.bool.isRequired,
      children: function children(props, propName) {
        if (_react2.default.Children.count(props[propName]) !== 2) return new Error('"' + propName + '" must be exactly two transition components.');

        return null;
      }
    };

    /**
     * The `<ReplaceTransition>` component is a specialized `Transition` component
     * that animates between two children.
     *
     * ```jsx
     * <ReplaceTransition in>
     *   <Fade><div>I appear first</div></Fade>
     *   <Fade><div>I replace the above</div></Fade>
     * </ReplaceTransition>
     * ```
     */

    var ReplaceTransition = function (_React$Component) {
      _inherits(ReplaceTransition, _React$Component);

      function ReplaceTransition() {
        var _temp, _this, _ret;

        _classCallCheck(this, ReplaceTransition);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
      }

      ReplaceTransition.prototype.handleLifecycle = function handleLifecycle(handler, idx, originalArgs) {
        var _child$props;

        var children = this.props.children;

        var child = _react2.default.Children.toArray(children)[idx];

        if (child.props[handler]) (_child$props = child.props)[handler].apply(_child$props, originalArgs);
        if (this.props[handler]) this.props[handler]((0, reactDom.findDOMNode)(this));
      };

      ReplaceTransition.prototype.render = function render() {
        var _props = this.props,
            children = _props.children,
            inProp = _props.in,
            props = _objectWithoutProperties(_props, ['children', 'in']);

        var _React$Children$toArr = _react2.default.Children.toArray(children),
            first = _React$Children$toArr[0],
            second = _React$Children$toArr[1];

        delete props.onEnter;
        delete props.onEntering;
        delete props.onEntered;
        delete props.onExit;
        delete props.onExiting;
        delete props.onExited;

        return _react2.default.createElement(
          _TransitionGroup2.default,
          props,
          inProp ? _react2.default.cloneElement(first, {
            key: 'first',
            onEnter: this.handleEnter,
            onEntering: this.handleEntering,
            onEntered: this.handleEntered

          }) : _react2.default.cloneElement(second, {
            key: 'second',
            onEnter: this.handleExit,
            onEntering: this.handleExiting,
            onEntered: this.handleExited
          })
        );
      };

      return ReplaceTransition;
    }(_react2.default.Component);

    var _initialiseProps = function _initialiseProps() {
      var _this2 = this;

      this.handleEnter = function () {
        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return _this2.handleLifecycle('onEnter', 0, args);
      };

      this.handleEntering = function () {
        for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
          args[_key3] = arguments[_key3];
        }

        return _this2.handleLifecycle('onEntering', 0, args);
      };

      this.handleEntered = function () {
        for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          args[_key4] = arguments[_key4];
        }

        return _this2.handleLifecycle('onEntered', 0, args);
      };

      this.handleExit = function () {
        for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
          args[_key5] = arguments[_key5];
        }

        return _this2.handleLifecycle('onExit', 1, args);
      };

      this.handleExiting = function () {
        for (var _len6 = arguments.length, args = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
          args[_key6] = arguments[_key6];
        }

        return _this2.handleLifecycle('onExiting', 1, args);
      };

      this.handleExited = function () {
        for (var _len7 = arguments.length, args = Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
          args[_key7] = arguments[_key7];
        }

        return _this2.handleLifecycle('onExited', 1, args);
      };
    };

    ReplaceTransition.propTypes = process.env.NODE_ENV !== "production" ? propTypes$$1 : {};

    exports.default = ReplaceTransition;
    module.exports = exports['default'];
    });

    unwrapExports(ReplaceTransition_1);

    var reactTransitionGroup = createCommonjsModule(function (module) {



    var _CSSTransition2 = _interopRequireDefault(CSSTransition_1);



    var _ReplaceTransition2 = _interopRequireDefault(ReplaceTransition_1);



    var _TransitionGroup2 = _interopRequireDefault(TransitionGroup_1);



    var _Transition2 = _interopRequireDefault(Transition_1);

    function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    module.exports = {
      Transition: _Transition2.default,
      TransitionGroup: _TransitionGroup2.default,
      ReplaceTransition: _ReplaceTransition2.default,
      CSSTransition: _CSSTransition2.default
    };
    });

    unwrapExports(reactTransitionGroup);
    var reactTransitionGroup_1 = reactTransitionGroup.Transition;
    var reactTransitionGroup_2 = reactTransitionGroup.TransitionGroup;
    var reactTransitionGroup_3 = reactTransitionGroup.ReplaceTransition;
    var reactTransitionGroup_4 = reactTransitionGroup.CSSTransition;

    var TransitioningComponent = /** @class */ (function (_super) {
        __extends(TransitioningComponent, _super);
        function TransitioningComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            // Transition complete function
            // tslint:disable-next-line:no-shadowed-variable
            _this.addEndListener = function (node, done) {
                node.addEventListener("transitionend", function () {
                    done();
                    if (_this.props.transitionEndCallback) {
                        _this.props.transitionEndCallback();
                    }
                }, false);
            };
            return _this;
        }
        TransitioningComponent.prototype.render = function () {
            var _this = this;
            var _a = this.props, enter = _a.enter, appear = _a.appear, children = _a.children, fadeOnSlide = _a.fadeOnSlide, timeout = _a.timeout;
            // These constants are being put here because the getter properties could get exact value before transition starts.
            // Putting it inside transition rendered block could produce undeterinistic values.
            var partialTransitioningComponentChildProps = {
                child: children,
                cssWrapperStyle: this.cssWrapperStyle,
                enteringTransform: this.enteringTransform,
                exitingTransform: this.exitingTransform,
                fadeOnSlide: fadeOnSlide || false,
                sliderEnterTimingFunction: this.sliderEnterTimingFunction,
                sliderExitTimingFunction: this.sliderExitTimingFunction,
                sliderTransitionEnterTime: this.sliderTransitionEnterTime,
                sliderTransitionExitTime: this.sliderTransitionExitTime,
                wrapperTransformCenter: this.wrapperTransformCenter
            };
            var renderState = function (state) {
                return _this.renderTransitioningChild(__assign({}, partialTransitioningComponentChildProps, { state: state }));
            };
            return (React.createElement(reactTransitionGroup_1, { in: enter, timeout: timeout, appear: appear, addEndListener: this.addEndListener }, renderState));
        };
        Object.defineProperty(TransitioningComponent.prototype, "sliderHorizontalMargin", {
            // Getter method for calculating horizontal margin
            // Useful when sliding direction is right/left.
            get: function () {
                var _a = this.props, parentRef = _a.parentRef, childStyles = _a.childStyles;
                var sliderElemMargin = 0;
                if (parentRef && parentRef.parentElement) {
                    sliderElemMargin =
                        parentRef.parentElement.offsetWidth - childStyles.width;
                }
                return sliderElemMargin;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "sliderVerticalMargin", {
            // Getter method for calculating vertical margin
            // Useful when sliding direction is up/down.
            get: function () {
                var _a = this.props, parentRef = _a.parentRef, childStyles = _a.childStyles;
                var sliderElemMargin = 0;
                if (parentRef && parentRef.parentElement) {
                    sliderElemMargin =
                        parentRef.parentElement.offsetHeight - childStyles.height;
                }
                return sliderElemMargin;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "horizontalFarDistance", {
            // Getter method for calculating the horizontal distance an element must travel.
            // Useful when sliding direction is right/left.
            get: function () {
                var _a = this.props, sizePercentageDuringSlide = _a.sizePercentageDuringSlide, childStyles = _a.childStyles, fadeOnSlide = _a.fadeOnSlide;
                var farDistance = childStyles.width + this.sliderHorizontalMargin;
                if (fadeOnSlide && sizePercentageDuringSlide) {
                    farDistance = childStyles.width * (1 - sizePercentageDuringSlide / 100);
                }
                return farDistance;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "verticalFarDistance", {
            // Getter method for calculating vertical distance an element must travel.
            // Useful when sliding direction is up/down.
            get: function () {
                var _a = this.props, sizePercentageDuringSlide = _a.sizePercentageDuringSlide, childStyles = _a.childStyles, fadeOnSlide = _a.fadeOnSlide;
                var farDistance = childStyles.height + this.sliderVerticalMargin;
                if (fadeOnSlide && sizePercentageDuringSlide) {
                    farDistance = childStyles.height * (1 - sizePercentageDuringSlide / 100);
                }
                return farDistance;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "wrapperStyleFarRight", {
            // Getter method for transform style if component is at right and is invisible.
            // Useful when sliding direction is right/left.
            get: function () {
                return "translate3d(" + this.horizontalFarDistance + "px, 0, 0)";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "wrapperStyleFarLeft", {
            // Getter method for transform style if component is at left and is invisible.
            // Useful when sliding direction is right/left.
            get: function () {
                return "translate3d(-" + this.horizontalFarDistance + "px, 0, 0)";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "wrapperStyleFarUp", {
            // Getter method for transform style if component is at up and is invisible.
            // Useful when sliding direction is up/down.
            get: function () {
                return "translate3d(0, -" + this.verticalFarDistance + "px, 0)";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "wrapperStyleFarDown", {
            // Getter method for transform style if component is at down and is invisible.
            // Useful when sliding direction is up/down.
            get: function () {
                return "translate3d(0, " + this.verticalFarDistance + "px, 0)";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "wrapperTransformCenter", {
            // Getter method for transform style if component is at center.
            get: function () {
                return "translate3d(0, 0, 0)";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "sliderTransitionExitTime", {
            // Getter method to calculate transition exit time.
            get: function () {
                var _a = this.props.childStyles, transitionTime = _a.transitionTime, exitTransitionTime = _a.exitTransitionTime;
                var time = exitTransitionTime || transitionTime;
                if (!time) {
                    throw new Error("Either exitTransitionTime or transitionTime should be present as props");
                }
                return time + "s";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "sliderTransitionEnterTime", {
            // Getter method to calculate transition enter time.
            get: function () {
                var _a = this.props.childStyles, transitionTime = _a.transitionTime, enterTransitionTime = _a.enterTransitionTime;
                var time = enterTransitionTime || transitionTime;
                if (!time) {
                    throw new Error("Either enterTransitionTime or transitionTime should be present as props");
                }
                return time + "s";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "sliderEnterTimingFunction", {
            // Getter method to calculate transition enter timing function css property.
            get: function () {
                var _a = this.props.childStyles, timingFunction = _a.timingFunction, enterTimingFunction = _a.enterTimingFunction;
                return enterTimingFunction || timingFunction || "linear";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "sliderExitTimingFunction", {
            // Getter method to calculate transition exit timing function css property.
            get: function () {
                var _a = this.props.childStyles, timingFunction = _a.timingFunction, exitTimingFunction = _a.exitTimingFunction;
                return exitTimingFunction || timingFunction || "linear";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "enteringTransform", {
            // Getter method to calculate css transform of entering element.
            // Calculates according to direction in which it will be transitioning.
            get: function () {
                var direction = this.props.direction;
                switch (direction) {
                    case 1 /* MoveRight */:
                        return this.wrapperStyleFarLeft;
                    case 0 /* MoveLeft */:
                        return this.wrapperStyleFarRight;
                    case 2 /* MoveUp */:
                        return this.wrapperStyleFarDown;
                    case 3 /* MoveDown */:
                        return this.wrapperStyleFarUp;
                    default:
                        throw new Error("No direction present");
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "exitingTransform", {
            // Getter method to calculate css transform of exiting element.
            // Calculates according to direction in which it will be transitioning.
            get: function () {
                var direction = this.props.direction;
                switch (direction) {
                    case 1 /* MoveRight */:
                        return this.wrapperStyleFarRight;
                    case 0 /* MoveLeft */:
                        return this.wrapperStyleFarLeft;
                    case 2 /* MoveUp */:
                        return this.wrapperStyleFarUp;
                    case 3 /* MoveDown */:
                        return this.wrapperStyleFarDown;
                    default:
                        throw new Error("No direction present");
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TransitioningComponent.prototype, "cssWrapperStyle", {
            // Get the wrapper css style, non dependent on state of transition.
            get: function () {
                var rtgWrapperStyles = getSliderStyles().rtgWrapper;
                var styles = __assign({}, rtgWrapperStyles, { height: this.props.childStyles.height, width: this.props.childStyles.width });
                var zIndex = this.props.childStyles.zIndex;
                return zIndex ? __assign({}, styles, { zIndex: zIndex }) : styles;
            },
            enumerable: true,
            configurable: true
        });
        // Abstraction of rendering child element. Used inside JSX rendering of child elem.
        TransitioningComponent.prototype.renderTransitioningChild = function (transitioningComponentChildProps) {
            return (React.createElement(TransitioningComponentChild, __assign({}, transitioningComponentChildProps, { enter: this.props.enter })));
        };
        return TransitioningComponent;
    }(React.Component));

    /**
     * @prop watchProp - The property to watch if on which sliding will occur. This must be a literal value.
     * @prop childProps - The properties of child element.
     * @prop direction - The direction in which this change's sliding effect should go.
     * @prop children - This child JSX element wrapped in Slider component on which sliding effect will happen.
     * @prop childStyles - Some styles of children, which includes width, height and transition timing related styles.
     * @prop slideOnAppear - If we want the sliding effect when we first see the screen. Optional Prop.
     * @prop fadeOnSlide - Should the slide fade on entering or exiting. Optional Prop.
     * @prop sizePercentageDuringSlide - % of size which should be on screen. Useful only with fadeOnSlide prop. Optional.
     * @prop transitionDone - Transition done callback. Optional.
     */
    var Slider = /** @class */ (function (_super) {
        __extends(Slider, _super);
        function Slider(props) {
            var _this = _super.call(this, props) || this;
            _this.transitionCycle = "full" /* Full */;
            _this.selfRef = null;
            _this.firstRender = true;
            _this.curWatchCount = 0;
            _this.prevWatchCount = 0;
            _this.enterTransitionDone = function () {
                _this.transitionCycle = "full" /* Full */;
                if (_this.props.transitionDone) {
                    _this.props.transitionDone();
                }
            };
            /**
             * This method makes two clones of child.
             * One with current properties which will enter and another with previous properties which will exit.
             */
            _this.getCLonedElems = function () {
                var _a = _this.state, prevWatchProp = _a.prevWatchProp, prevChildProps = _a.prevChildProps, nextWatchProp = _a.nextWatchProp, nextChildProps = _a.nextChildProps;
                var _b = _this.props, direction = _b.direction, childStyles = _b.childStyles, slideOnAppear = _b.slideOnAppear, fadeOnSlide = _b.fadeOnSlide, sizePercentageDuringSlide = _b.sizePercentageDuringSlide, children = _b.children;
                var clonedElems = [];
                var enterTimeout = (childStyles.transitionTime || childStyles.enterTransitionTime || 1) *
                    100;
                var exitTimeout = (childStyles.transitionTime || childStyles.exitTransitionTime || 1) * 100;
                var preparedChildStylesEnter = __assign({}, childStyles, { zIndex: 2 });
                if (noNullOrUndefined(nextWatchProp) && nextChildProps) {
                    clonedElems.push(React.createElement(TransitioningComponent, { enter: true, direction: direction, key: "s_" + _this.curWatchCount + nextWatchProp, appear: slideOnAppear || noNullOrUndefined(prevWatchProp), parentRef: _this.selfRef, childStyles: preparedChildStylesEnter, fadeOnSlide: fadeOnSlide, sizePercentageDuringSlide: sizePercentageDuringSlide, timeout: enterTimeout, transitionEndCallback: _this.enterTransitionDone }, React.cloneElement(children, nextChildProps)));
                }
                var preparedChildStylesExit = __assign({}, childStyles, { zIndex: 1 });
                if (noNullOrUndefined(prevWatchProp) &&
                    prevWatchProp !== nextWatchProp &&
                    prevChildProps) {
                    clonedElems.push(React.createElement(TransitioningComponent, { enter: false, direction: direction, key: "s_" + _this.prevWatchCount + prevWatchProp, appear: true, parentRef: _this.selfRef, childStyles: preparedChildStylesExit, fadeOnSlide: fadeOnSlide, sizePercentageDuringSlide: sizePercentageDuringSlide, timeout: exitTimeout }, React.cloneElement(children, prevChildProps)));
                }
                return clonedElems;
            };
            _this.state = {
                nextChildProps: null,
                nextWatchProp: null,
                prevChildProps: null,
                prevWatchProp: null
            };
            return _this;
        }
        Slider.getDerivedStateFromProps = function (nextProps, prevState) {
            return {
                nextChildProps: nextProps.childProps,
                nextWatchProp: nextProps.watchProp,
                prevChildProps: prevState.nextChildProps,
                prevWatchProp: prevState.nextWatchProp
            };
        };
        Slider.prototype.shouldComponentUpdate = function (nextProps) {
            var validTransitionCycleState = this.transitionCycle === "full" /* Full */ ||
                this.transitionCycle === "start" /* Start */;
            var isWatchPropDifferent = this.props.watchProp !== nextProps.watchProp;
            return validTransitionCycleState && isWatchPropDifferent;
        };
        Slider.prototype.render = function () {
            var _this = this;
            this.beforeUpdationProcess();
            var _a = this.props.childStyles, width = _a.width, height = _a.height;
            var rtgListStyles = getSliderStyles().rtgList;
            var styles = __assign({}, rtgListStyles, { width: width, height: height });
            return (React.createElement("div", { ref: function (elem) { return (_this.selfRef = elem); }, style: styles, className: this.props.className }, this.getCLonedElems()));
        };
        Slider.prototype.beforeUpdationProcess = function () {
            var _a = this.props, children = _a.children, watchProp = _a.watchProp;
            if (!React.isValidElement(children)) {
                throw new Error("Wrapped child is not a valid react element");
            }
            if (Array.isArray(children)) {
                throw new Error("Only single child can be passed in slider component");
            }
            if (typeof children === "string") {
                throw new Error("Wrapped child cannot be string, it should be a single react element");
            }
            if (typeof watchProp === "undefined" || isNull(watchProp)) {
                throw new Error("**watchProp** cannot be null or undefined");
            }
            if (watchProp === Object(watchProp)) {
                throw new Error("**watchProp** must be either string, number or boolean");
            }
            if (this.transitionCycle !== "full" /* Full */) {
                console.warn("Slider(React-Animation-Suite): You should not change properties unless transition cycle is fully complete.\n        Please manage this in your code by using **transitionDone** callback prop");
            }
            if (!this.firstRender) {
                this.transitionCycle = "start" /* Start */;
            }
            else {
                this.firstRender = false;
            }
            if (this.state.nextWatchProp !== this.state.prevWatchProp) {
                this.prevWatchCount = this.curWatchCount;
                this.curWatchCount += 1;
            }
        };
        return Slider;
    }(React.Component));

    (function (ISliderDirection) {
        ISliderDirection[ISliderDirection["MoveLeft"] = 0] = "MoveLeft";
        ISliderDirection[ISliderDirection["MoveRight"] = 1] = "MoveRight";
        ISliderDirection[ISliderDirection["MoveUp"] = 2] = "MoveUp";
        ISliderDirection[ISliderDirection["MoveDown"] = 3] = "MoveDown";
    })(exports.ISliderDirection || (exports.ISliderDirection = {}));
    var SliderCycleState;
    (function (SliderCycleState) {
        SliderCycleState["Start"] = "start";
        SliderCycleState["Half"] = "half";
        SliderCycleState["Full"] = "full";
    })(SliderCycleState || (SliderCycleState = {}));

    (function (IRevealDirection) {
        IRevealDirection[IRevealDirection["MoveDown"] = 0] = "MoveDown";
        IRevealDirection[IRevealDirection["MoveRight"] = 1] = "MoveRight";
    })(exports.IRevealDirection || (exports.IRevealDirection = {}));

    /**
     * @prop show: boolean
     * @prop direction: like ISliderDirection 0: left, 1: right, 2: up, 3: down
     * @prop withFade?: boolean
     * @prop fixedDistance?: revealTill a distance and show scrollbar
     * @prop childStyles?: all lise ISliderChildStyles except width or height
     * @prop mountUnmountAuthority
     */
    var Reveal = /** @class */ (function (_super) {
        __extends(Reveal, _super);
        function Reveal() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.checkBeforeRender = function () {
                var _a = _this.props.childStyles, transitionTime = _a.transitionTime, enterTransitionTime = _a.enterTransitionTime, exitTransitionTime = _a.exitTransitionTime;
                if (!transitionTime) {
                    if (!(enterTransitionTime && exitTransitionTime)) {
                        throw new Error("If transition time is not defined then both enter transition time and exit transition time should be defined");
                    }
                }
            };
            _this.cssHeightWidthPropWithValue = function (forMax) {
                var styles = {};
                if (_this.props.direction === exports.IRevealDirection.MoveDown) {
                    if (forMax) {
                        styles = { maxHeight: "100vh" };
                    }
                    else {
                        styles = {
                            maxHeight: _this.props.childStyles.minMeasureValue || "0px"
                        };
                    }
                }
                else if (_this.props.direction === exports.IRevealDirection.MoveRight) {
                    if (forMax) {
                        styles = { maxWidth: "100vw" };
                    }
                    else {
                        styles = {
                            maxWidth: _this.props.childStyles.minMeasureValue || "0px"
                        };
                    }
                }
                else {
                    throw new Error("Either direction prop is not present or it's value provided is wrong");
                }
                return styles;
            };
            return _this;
        }
        Reveal.prototype.render = function () {
            var _this = this;
            this.checkBeforeRender();
            var _a = this.props, show = _a.show, mountUnmountAuthority = _a.mountUnmountAuthority, children = _a.children, withFade = _a.withFade, revealOnAppear = _a.revealOnAppear;
            return (React.createElement(reactTransitionGroup_1, { in: show, mountOnEnter: mountUnmountAuthority, unmountOnExit: mountUnmountAuthority, timeout: {
                    enter: 1,
                    exit: this.exitTransitionTime * 1000
                }, appear: revealOnAppear || false }, function (state) {
                var wrapperStyle;
                switch (state) {
                    case "entering":
                        wrapperStyle = __assign({}, _this.cssHeightWidthPropWithValue(false), { opacity: withFade ? 0 : 1 });
                        break;
                    case "entered":
                        wrapperStyle = __assign({}, _this.cssHeightWidthPropWithValue(true), { opacity: 1, transition: _this.cssDirection + " " + _this.enterTransitionTime + "s " + _this.enterTimingFunction + ", opacity " + _this.enterTransitionTime + "s " + _this.enterTimingFunction });
                        break;
                    case "exiting":
                        wrapperStyle = __assign({}, _this.cssHeightWidthPropWithValue(false), { opacity: withFade ? 0 : 1, transition: _this.cssDirection + " " + _this.exitTransitionTime + "s " + _this.exitTimingFunction + ", opacity " + _this.exitTransitionTime + "s " + _this.exitTimingFunction });
                        break;
                    case "exited":
                        wrapperStyle = __assign({}, _this.cssHeightWidthPropWithValue(false), { opacity: withFade ? 0 : 1 });
                        break;
                }
                var allStyles = __assign({}, wrapperStyle, _this.normalStyles);
                return React.createElement("div", { style: allStyles }, children);
            }));
        };
        Object.defineProperty(Reveal.prototype, "enterTransitionTime", {
            get: function () {
                var _a = this.props.childStyles, transitionTime = _a.transitionTime, enterTransitionTime = _a.enterTransitionTime;
                return enterTransitionTime || transitionTime || 1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Reveal.prototype, "exitTransitionTime", {
            get: function () {
                var _a = this.props.childStyles, transitionTime = _a.transitionTime, exitTransitionTime = _a.exitTransitionTime;
                return exitTransitionTime || transitionTime || 1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Reveal.prototype, "enterTimingFunction", {
            get: function () {
                var _a = this.props.childStyles, timingFunction = _a.timingFunction, enterTimingFunction = _a.enterTimingFunction;
                return enterTimingFunction || timingFunction || "linear";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Reveal.prototype, "exitTimingFunction", {
            get: function () {
                var _a = this.props.childStyles, timingFunction = _a.timingFunction, exitTimingFunction = _a.exitTimingFunction;
                return exitTimingFunction || timingFunction || "linear";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Reveal.prototype, "normalStyles", {
            get: function () {
                return {
                    overflow: "hidden"
                };
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Reveal.prototype, "cssDirection", {
            get: function () {
                if (this.props.direction === exports.IRevealDirection.MoveDown) {
                    return "max-height";
                }
                else if (this.props.direction === exports.IRevealDirection.MoveRight) {
                    return "max-width";
                }
                else {
                    throw new Error("Either direction prop is not present or it's value provided is wrong");
                }
            },
            enumerable: true,
            configurable: true
        });
        return Reveal;
    }(React.Component));

    exports.Slider = Slider;
    exports.Reveal = Reveal;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
