"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var utils_1 = require("./utils");
function TransitioningComponentChild(props) {
    var wrapperStyles;
    switch (props.state) {
        case "entering":
            wrapperStyles = utils_1.getWrapperStyles(props.enteringTransform, "0", props.fadeOnSlide ? 0 : 1);
            break;
        case "entered":
            wrapperStyles = props.enter
                ? utils_1.getWrapperStyles(props.wrapperTransformCenter, props.sliderTransitionEnterTime, 1, props.sliderEnterTimingFunction)
                : utils_1.getWrapperStyles(props.wrapperTransformCenter, "0", 1);
            break;
        case "exiting":
            wrapperStyles = utils_1.getWrapperStyles(props.wrapperTransformCenter, "0", 1);
            break;
        case "exited":
            wrapperStyles = props.enter
                ? utils_1.getWrapperStyles(props.enteringTransform, "0", props.fadeOnSlide ? 0 : 1)
                : utils_1.getWrapperStyles(props.exitingTransform, props.sliderTransitionExitTime, props.fadeOnSlide ? 0 : 1, props.sliderExitTimingFunction);
            break;
        default:
            throw new Error("Transition has no state");
    }
    return (React.createElement("div", { style: __assign({}, wrapperStyles, props.cssWrapperStyle) }, props.child));
}
exports.TransitioningComponentChild = TransitioningComponentChild;
//# sourceMappingURL=TransitioningComponentChild.js.map