"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("util");
/**
 * Function to get the wrapper style for transitioning child
 * @param transform Value of transform property of css
 * @param transition Value of transition property of css
 * @param opacity Value of opacity property of css
 * @param transitionTimingFunction Value of transition-timing-function property of css
 * @returns Css styles in json format
 */
function getWrapperStyles(transform, transition, opacity, transitionTimingFunction) {
    return { transform: transform, transition: transition, opacity: opacity, transitionTimingFunction: transitionTimingFunction };
}
exports.getWrapperStyles = getWrapperStyles;
/**
 * This function checks if a variable is not undef or not null
 * @param subjectArg
 */
function noNullOrUndefined(subjectArg) {
    return typeof subjectArg !== "undefined" && !util_1.isNull(subjectArg);
}
exports.noNullOrUndefined = noNullOrUndefined;
//# sourceMappingURL=utils.js.map