import * as React from "react";
import { ISliderChildStyles, ISliderDirection } from "./types";
interface ITransitioningComponentProps {
    enter: boolean;
    direction: ISliderDirection;
    appear: boolean;
    children: JSX.Element;
    parentRef: HTMLDivElement | null;
    childStyles: ISliderChildStyles;
    timeout: number;
    fadeOnSlide?: boolean;
    sizePercentageDuringSlide?: number;
    transitionEndCallback?: () => void;
}
export default class TransitioningComponent extends React.Component<ITransitioningComponentProps> {
    render(): JSX.Element;
    private readonly sliderHorizontalMargin;
    private readonly sliderVerticalMargin;
    private readonly horizontalFarDistance;
    private readonly verticalFarDistance;
    private readonly wrapperStyleFarRight;
    private readonly wrapperStyleFarLeft;
    private readonly wrapperStyleFarUp;
    private readonly wrapperStyleFarDown;
    private readonly wrapperTransformCenter;
    private readonly sliderTransitionExitTime;
    private readonly sliderTransitionEnterTime;
    private readonly sliderEnterTimingFunction;
    private readonly sliderExitTimingFunction;
    private readonly enteringTransform;
    private readonly exitingTransform;
    private readonly cssWrapperStyle;
    private renderTransitioningChild;
    private addEndListener;
}
export {};
